<template>
  <el-dialog
    :title="title"
    :visible.sync="open"
    width="70%"
    append-to-body
    :close-on-click-modal="false"
    @close="cancel"
  >
    <div class="form-dialog-box"
    v-loading="loading"
    :element-loading-text="loadingText"
    element-loading-spinner="el-icon-loading"
    element-loading-background="rgba(0, 0, 0, 0.8)">
      <el-form :model="form" ref="form" :rules="rules" label-width="120px">
        <el-form-item label="点位名称：" prop="name">
          <el-input style="width: 350px;" v-model="form.name" placeholder="请输入点位名称" maxlength="20" show-word-limit />
        </el-form-item>
        <el-form-item label="点位类型：" prop="typeId">
          <el-select v-model="form.typeId" placeholder="请选择点位类型">
            <el-option
              v-for="item in pointTypeList"
              :key="item.id"
              :label="item.name"
              :value="item.id">
            </el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="地图定位：">
          <div style="display: flex;">
            <el-form-item label="经度：" label-width="80px" prop="longitude">
              <el-input style="width: 350px;" v-model="form.longitude" placeholder="请输入点位名称" />
            </el-form-item>
            <el-form-item label="纬度：" prop="latitude">
              <el-input style="width: 350px;" v-model="form.latitude" placeholder="请输入点位名称" />
            </el-form-item>
          </div>
        </el-form-item>
        <!-- 腾讯地图  -->
        <div>

        </div>
      </el-form>
    </div>
    <span slot="footer" class="dialog-footer" v-if="formStatus==1">
      <el-button @click="cancel">取消</el-button>
      <el-button
        type="primary"
        @click="submitForm"
        :loading="loading"
        element-loading-text="提交中..."
        element-loading-spinner="el-icon-loading"
        element-loading-background="rgba(0, 0, 0, 0.8)"
      > 
        {{ loading ? '提交中...' : '保存' }}
      </el-button>
    </span>
    <!-- 添加或修改对话框 End -->
  </el-dialog>
</template>

<script>
import { 
  getTableDeatilsByIdApi,
  updateTableApi,
  addTableApi,
  listTableApi
 } from '@/api/CURD'

export default {
  name: "addAndEdit",
  dicts: [],
  data() {
    return {
      title: "",
      model: "", // EDIT: 编辑模式 ADD : 新增模式  EDITInit : 编辑模式（需要请求详情）
      open: false,
      loading: false,
      loadingText: "拼命加载数据中...",
      formStatus: null, // 0/null : 加载中 1 : 获取详情成功 2  : 获取详情失败 
      configUrl: {
        add: '/merchant/merchantMapMark/insertOrUpdate', // 新增地址
        details: '', // 详情地址
        edit: '/merchant/merchantMapMark/insertOrUpdate', // 编辑地址
        pointTypeList: '/merchant/merchantMapMarkType/list'
      },
      form: {
        id: undefined,
      },
      rules: {
        name: [{ required: true, message: "请输入点位名称", trigger: ["change","blur"] }],
        typeId: [{ required: true, message: "请选中点位类型", trigger: ["change","blur"] }],
        longitude: [{ required: false, message: "请输入经度", trigger: ["change","blur"] }],
        latitude: [{ required: true, message: "请输入纬度", trigger: ["change","blur"] }],
        content: [{ required: true, message: "请输入开放状态", trigger: ["change","blur"] }],
      },
      pointTypeList: [],// 景点产品关联
    };
  },
  created() {
    this.getPointList()
  },
  methods: {
    async initData(title , model,row){
      this.title = title
      this.open = true
      this.loadingText = "拼命加载数据中..."
      this.loading = true
      this.model = model
      this.formStatus = 0
      if(model=='ADD') { // 新增
        this.$set(this,'form',row)
        this.formStatus = 1
      }else if(model=='EDIT') { // 新增
        let obj = {
          ...row,
          openDate: row.openDate?row.openDate.join('~') : null
        }
        this.$set(this,'form',obj)
        this.formStatus = 1
      }else if(model=='EDITInit') { // 新增
        await this.getTableDeatilsFun(row)
      }
      this.loading = false
      this.$nextTick(()=>{
        if(this.$refs["form"]) {
          this.$refs["form"].clearValidate();
        }
      })
    },
    /** 获取详情 */
    async getTableDeatilsFun(row) {
      const id = row.id
      this.loading = true
      try {
        let res = await getTableDeatilsByIdApi(this.configUrl.details,{id})
        if(res.code == 200) {
          let obj = {
            ...res.data
          }
          this.$set(this,'form',JSON.parse(JSON.stringify(obj)))
          this.formStatus = 1
        }else {
          this.$message.error('获取详情失败!!!');
          this.formStatus = 2
          this.loading = false
          this.open = false;
        }
        this.loading = false
      } catch (error) {
        console.error('获取详情失败!!!!',error)
        this.formStatus = 2
        this.loading = false
        this.open = false;
      }
    },
    /**
     * 保存
     * @date 2023-11-22
     * @returns {any}
     */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          this.loadingText = "提交数据中..."
          this.loading = true
          this.loadingText = "提交数据中..."
          if (this.model != 'ADD') {
            addTableApi(
              this.configUrl.edit,{
                ...this.form
              }).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.loading = false
              this.open = false;
              this.$emit('refresh')
            }).catch(()=>{
              this.$message.error("修改失败!!!");
              this.loading = false
            })
          } else {
            addTableApi(this.configUrl.edit,{
                ...this.form
              }).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.loading = false
              this.open = false;
              this.$emit('refresh')
            }).catch(()=>{
              this.$message.error("新增失败!!!");
              this.loading = false
            })
          }
        }
      });
    },
    /**
     * 重置
     * @date 2023-11-22
     * @returns {any}
     */
    reset() {
      if(this.$refs["form"]) {
        this.$refs["form"].clearValidate();
      }
    },
    /**
     * 关闭弹框
     * @date 2023-11-22
     * @returns {any}
     */
    cancel() {
      this.reset();
      this.open = false;
    },
    /** 查询用户列表 */
    getPointList() {
      listTableApi(
        this.configUrl.pointTypeList,
        {
          pageSize: 999,
          pageNum: 1
        }).then(response => {
            this.pointTypeList = response.data.rows;
        }
      ).catch (error=>{
        console.error('获取点位类型失败!!!!',error)
        this.pointTypeList = [];
      }) 
    },
  },
};
</script>

<style lang="scss" scoped>
.form-dialog-box {
  padding: 0 30px;
  padding: 0 30px;
  min-height: 50vh;
  max-height: 65vh;
  overflow-y: auto;
  .form-title {
    padding: 0 0 10px 0;
    span {
      display: flex;
      color: rgba(65,80,88,1);
      font-size: 16px;
      font-family: SourceHanSansSC;
      font-weight: 700;
      line-height: 23px;
      border-left: 4px solid rgb(22, 132, 252);
      padding-left: 10px;
    }
    
  }
  ::v-deep .ql-editor {
    height: 400px;
  }
  .upload-btn {
    width: 100px;
    height: 100px;
    background-color: #fbfdff;
    border: dashed 1px #c0ccda;
    border-radius: 5px;
    i {
      font-size: 30px;
      margin-top: 20px;
    }
    &-text {
      margin-top: -10px;
    }
  }
  .avatar {
    cursor: pointer;
  }
}
.el-table{
  .upload-btn {
    width: 100px;
    height: 100px;
    background-color: #fbfdff;
    border: dashed 1px #c0ccda;
    border-radius: 5px;
    i {
      font-size: 30px;
      margin-top: 20px;
    }
    &-text {
      margin-top: -10px;
    }
  }
  .avatar {
    cursor: pointer;
  }
}

.area-container {
  min-height: 400px;
}

::v-deep .area-wrap-city.el-cascader {
  line-height: normal;
  .el-input {
    cursor: pointer;
    width: 100% !important;
    height: 28px !important;
    .el-input__inner {
      display: none !important;
    }
    span.el-input__suffix {
      position: inherit !important;
      i.el-input__icon {
        line-height: inherit;
        margin-left: 5px;
      }
    }

    .el-input__wrapper {
      box-shadow: none;
      input {
        display: none;
      }
    }
  }

  .el-cascader__tags {
    display: none;
  }
}

.area-city-popper {
  .el-cascader-panel {
    .el-scrollbar.el-cascader-menu {
      .el-cascader-menu__wrap.el-scrollbar__wrap {
        height: 315px;
      }
    }
  }
}
</style>
<style>
.custom-class-box {
  z-index: 999999 !important;
}
</style>